require("hump.class")
require("LUBE")
require("pickle")
anim8 = require("anim8")

function love.load()
    --Connection Settings
    mode = 'Connecting'
    password = 'default'
    
    ip = ''
    username = ''
    port = ''
    setting = 'ip'
    
    DataPack = {}
    RDataPack = {}
    --
    
    --World Settings
    worldx = 0
    worldy = 0
    --
    
    --Screen Settings
    SW = 1000
    SH = 1000
    love.graphics.setMode(SW, SH)
    --
    
    --Text
    text = ''
    Lines = {}
    --
    
    --Load Images
    Dirt = love.graphics.newImage("assets/dirt.png")
    Air = love.graphics.newImage("assets/air.png")
    --
end

function love.update(dt)
    if mode ~= 'Connecting' then
        connection:update(dt)
    end
    
    if mode == 'Connecting' then
        function love.keypressed(key, unicode)
            if unicode > 31 and unicode < 127 then
                text = text .. string.char(unicode)
            end
            
            if key == "backspace" then
                text = text:sub(1, #text - 1)
            end
            
            if key == 'return' then
                if setting == 'ip' then
                    ip = text
                    setting = 'port'
                    text = '89017'
                elseif setting == 'port' then
                    port = tonumber(text)
                    setting = 'username'
                    text = ''
                elseif setting == 'username' then
                    username = text
                    setting = ''
                    text = ''
                    InitiateConnection()
                end
            end
        end
    end
end

function InitiateConnection()
    connection = lube.udpClient()
    connection.handshake = password
    connection:connect(ip, port, false)
    connection.callbacks.recv = call_recv
    DataPack = {breed = "ConnectionData", name = username}
    SendData()
    mode = 'InLobby'
end

function call_recv(data)
    RDataPack = unpickle(data)
    if RDataPack.breed == "WorldData" then
        worldx = RDataPack.worldx
        worldy = RDataPack.worldy
        CreateWorld()
        mode = 'InGame'
    elseif RDataPack.breed == "Seed" then
        math.randomseed(RDataPack.seed)
    end
end

function CreateWorld()
    World = {}
    for i = 1, worldx do
        World [i] = {}
    end

    for i = 1, worldx do
        for j = 1, worldy do
            World [i][j] = {tile = 'air', health = 1}
        end
    end
    
    for i = 1, worldx do
        for j = 1, worldy / 2 do
            World [i][j + (worldy / 2)] = {tile = 'dirt', health = 50}
        end
    end
end

function SendData()
    DataPack = pickle(DataPack)
    connection:send(DataPack)
end

function love.draw()
    if mode == 'InGame' then
        for i = 1, worldx do
            for j = 1, worldy do
                if World[i][j].tile == air then
                    love.graphics.draw(Air, i*20, j*20, 0, 1, 1, 14, 8)
                elseif World[i][j].tile == dirt then
                    love.graphics.draw(Air, i*20, j*20, 0, 1, 1, 14, 8)
                end
            end
        end
    elseif mode == 'Connecting' then
        love.graphics.setColor(250, 250, 250)
        love.graphics.printf(text, SW / 2, SW / 2, 1000, 'left')
        love.graphics.printf(setting, SW / 2, SW / 2 - 20, 1000, 'left')
    end
    love.graphics.printf(mode, SW / 2 - 10, 0, 100, 'center')
end

function love.quit()
	connection:disconnect()
end